#define _WIN32_MAXVER           0x0601
#define _WIN32_WINDOWS_MAXVER   0x0601
#define NTDDI_MAXVER            0x06010000
#define _WIN32_IE_MAXVER        0x0800
#define _WIN32_WINNT_MAXVER     0x0601
#define WINVER_MAXVER           0x0601

#ifndef _WIN32_WINNT
#define _WIN32_WINNT 0x0600
#endif

#ifndef NTDDI_VERSION
#define NTDDI_VERSION 0x06000000
#endif

#include <sdkddkver.h>
#include <windows.h>
#include <tlhelp32.h>
#include <string.h>
#include <imagehlp.h>
#include <stdio.h>
#include <stdlib.h>

// Main dll filename
#define DLL_NAME L"BypassESU.dll"

#define CBS_KEY L"SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Component Based Servicing\\Version"

// Original functions typedef
typedef HMODULE(WINAPI *pfnLoadLibraryW)(LPCWSTR lpFileName);
typedef HRESULT(WINAPI *pfnSLGetWindowsInformationDWORD)(PCWSTR pwszValueName, PDWORD pdwValue);
typedef BOOL(WINAPI *pfnGetProductInfo)(DWORD dwOSMajorVersion, DWORD dwOSMinorVersion, DWORD dwSpMajorVersion, DWORD dwSpMinorVersion, PDWORD pdwReturnedProductType);

// Hook functions prototype
HMODULE WINAPI LoadLibraryW_Hook(LPCWSTR lpFileName);
HRESULT WINAPI SLGetWindowsInformationDWORD_Hook(PCWSTR pwszValueName, PDWORD pdwValue);
BOOL WINAPI GetProductInfo_Hook(DWORD dwOSMajorVersion, DWORD dwOSMinorVersion, DWORD dwSpMajorVersion, DWORD dwSpMinorVersion, PDWORD pdwReturnedProductType);

typedef struct _APIHook {
	const char *module;
	const char *name;
	void* hook;
	void* original;
} APIHook;

#ifdef _DEBUG
#   define OutputDebugStringEx( str, ... ) \
      { \
        WCHAR c[512]; \
        swprintf_s( c, _countof(c), str, ##__VA_ARGS__ ); \
        OutputDebugStringW( c ); \
      }
#else
#    define OutputDebugStringEx( str, ... )
#endif

// Function prototype
BOOL WINAPI PatchIAT(HMODULE hModule);
BOOL WINAPI InjectDll(LPCWSTR lpDllName, DWORD dwProcessId);

// Original function pointers
#define DEFINE_HOOK(module, name) { module, #name, (void*)name##_Hook, NULL } 
#define CALL_ORIGINAL_FUNC(name, ...) (*(pfn##name)(APIHooks[name##_Index].original))(__VA_ARGS__)

typedef enum _APIIndex {
	LoadLibraryW_Index = 0,
	GetProductInfo_Index,
	SLGetWindowsInformationDWORD_Index
} APIIndex;

APIHook APIHooks[] =
{
	DEFINE_HOOK("kernel32.dll", LoadLibraryW),
	DEFINE_HOOK("kernel32.dll", GetProductInfo),
	DEFINE_HOOK("slc.dll", SLGetWindowsInformationDWORD)
};

HMODULE WINAPI LoadLibraryW_Hook(LPCWSTR lpFileName)
{
	HMODULE hModule = CALL_ORIGINAL_FUNC(LoadLibraryW, lpFileName);

	if (hModule == NULL)
	{
		SetLastError(GetLastError());
		return NULL;
	}

	OutputDebugStringEx(L"[BypassESU] LoadLibraryW called. [lpFileName: %s, base: 0x%p]\n", lpFileName, hModule);

	WCHAR lpUpCaseFileName[_MAX_PATH];
	wcscpy_s(lpUpCaseFileName, _countof(lpUpCaseFileName), lpFileName);
	_wcsupr_s(lpUpCaseFileName, _countof(lpUpCaseFileName));

	if ( !wcsstr(lpUpCaseFileName, L"EXTENDEDSECURITYUPDATESAI.DLL") && !wcsstr(lpUpCaseFileName, L"WUAUENG.DLL") )
	{
		OutputDebugStringEx(L"[BypassESU] Not a target module. Skipped patching...\n");
		return hModule;
	}

	PatchIAT(hModule);

	return hModule;
}

HRESULT WINAPI SLGetWindowsInformationDWORD_Hook(PCWSTR pwszValueName, PDWORD pdwValue)
{
	OutputDebugStringEx(L"[BypassESU] SLGetWindowsInformationDWORD: %ls\n", pwszValueName);

	if (wcsstr(pwszValueName, L"Client-ESU") ||
		wcsstr(pwszValueName, L"Server-ESU") ||
		wcsstr(pwszValueName, L"POS-ESU") ||
		wcsstr(pwszValueName, L"WES-ESU") ||
		wcsstr(pwszValueName, L"Client-FES-ESU") ||
		wcsstr(pwszValueName, L"Server-FES-ESU")
	) {
		*pdwValue = 0x1;
		return S_OK;
	}

	return CALL_ORIGINAL_FUNC(SLGetWindowsInformationDWORD, pwszValueName, pdwValue);
}

BOOL WINAPI GetProductInfo_Hook(DWORD dwOSMajorVersion, DWORD dwOSMinorVersion, DWORD dwSpMajorVersion, DWORD dwSpMinorVersion, PDWORD pdwReturnedProductType)
{
	OSVERSIONINFOEXW VersionInfo;
	VersionInfo.dwOSVersionInfoSize = sizeof(OSVERSIONINFOEXW);
	GetVersionExW((LPOSVERSIONINFOW)&VersionInfo);

	if (VersionInfo.wProductType == VER_NT_WORKSTATION) {
		// Windows Client - Professional
		*pdwReturnedProductType = 0x30;
		OutputDebugStringEx(L"[BypassESU] GetProductInfo: %u\n", *pdwReturnedProductType);
		return TRUE;
	} else {
		// Windows Server - ServerStandard
		*pdwReturnedProductType = 0x7;
		OutputDebugStringEx(L"[BypassESU] GetProductInfo: %u\n", *pdwReturnedProductType);
		return TRUE;
	}

	return CALL_ORIGINAL_FUNC(GetProductInfo, dwOSMajorVersion, dwOSMinorVersion, dwSpMajorVersion, dwSpMinorVersion, pdwReturnedProductType);
}

void CALLBACK PatcherMain(HWND hWnd, HINSTANCE hInstance, LPWSTR lpCmdLine, int nShowCmd)
{
	UNREFERENCED_PARAMETER(hWnd);
	UNREFERENCED_PARAMETER(hInstance);
	UNREFERENCED_PARAMETER(nShowCmd);

	STARTUPINFOW si;
	PROCESS_INFORMATION pi = { 0 };
	DWORD dwRet = ERROR_SUCCESS;
	BOOL bRet;

	GetStartupInfoW(&si);

	bRet = CreateProcessW(NULL, lpCmdLine, NULL, NULL, FALSE, DEBUG_PROCESS | DEBUG_ONLY_THIS_PROCESS | CREATE_SUSPENDED | DETACHED_PROCESS, NULL, NULL, &si, &pi);
	if (!bRet)
	{
		dwRet = GetLastError();
		OutputDebugStringEx(L"[BypassESU] CreateProcess failed [cmdLine: %s, error: 0x%08u].\n", lpCmdLine, dwRet);
		goto fail;
	}

	bRet = DebugActiveProcessStop(pi.dwProcessId);
	if (!bRet)
	{
		dwRet = GetLastError();
		OutputDebugStringEx(L"[BypassESU] DebugActiveProcessStop failed [error: 0x%08u].\n", dwRet);
		goto fail;
	}

	OutputDebugStringEx(L"[BypassESU] CreateProcess succeeded [cmdLine: %s, pid: %u, tid: %u].\n", lpCmdLine, pi.dwProcessId, pi.dwThreadId);
	Sleep(100);
	//SuspendThread(pi.hThread);
	InjectDll(DLL_NAME, pi.dwProcessId);

fail:
	ResumeThread(pi.hThread);

	WaitForSingleObject(pi.hProcess, INFINITE);
	GetExitCodeProcess(pi.hProcess, &dwRet);
	OutputDebugStringEx(L"[BypassESU] Process %s [pid: %u] exited with code %u.\n", lpCmdLine, pi.dwProcessId, dwRet);

	CloseHandle(pi.hProcess);
	CloseHandle(pi.hThread);

	ExitProcess(dwRet);
}

BOOL WINAPI InjectDll(LPCWSTR lpDllName, DWORD dwProcessId)
{
	BOOL bRet = FALSE;

	HANDLE hProcess = NULL;
	LPVOID addrDllPath = NULL;

	do
	{
		hProcess = OpenProcess(PROCESS_ALL_ACCESS, FALSE, dwProcessId);
		if (NULL == hProcess)
			break;

		SIZE_T allocSize = (wcslen(lpDllName) + 1) * sizeof(WCHAR);
		addrDllPath = VirtualAllocEx(hProcess, NULL, allocSize, MEM_RESERVE | MEM_COMMIT, PAGE_READWRITE);
		if (NULL == addrDllPath)
			break;

		if (!WriteProcessMemory(hProcess, addrDllPath, lpDllName, allocSize, NULL))
			break;

		pfnLoadLibraryW addrLoadLibraryW = (pfnLoadLibraryW)GetProcAddress(GetModuleHandleA("kernel32.dll"), "LoadLibraryW");
		if (addrLoadLibraryW == NULL)
			break;

		HANDLE hThread = CreateRemoteThread(hProcess, NULL, 0, (LPTHREAD_START_ROUTINE)addrLoadLibraryW, addrDllPath, 0, NULL);
		if (hThread == NULL)
			break;

		WaitForSingleObject(hThread, INFINITE);

		DWORD dwExitCode;
		GetExitCodeThread(hThread, &dwExitCode);
		CloseHandle(hThread);

		if (dwExitCode != 0)
			bRet = TRUE;

	} while (FALSE);

	if (addrDllPath != NULL)
		VirtualFreeEx(hProcess, addrDllPath, 0, MEM_RELEASE);
	if (hProcess != NULL)
		CloseHandle(hProcess);

	return bRet;
}

PIMAGE_IMPORT_DESCRIPTOR WINAPI GetImportDescriptor(HMODULE hModule)
{
	PIMAGE_NT_HEADERS pNtHeaders;
	PIMAGE_OPTIONAL_HEADER pOptionalHeader;
	PIMAGE_DATA_DIRECTORY pDirectory;
	ULONG_PTR Address;
	LPBYTE pb = (LPBYTE)hModule;

	if (((WORD *)pb)[0] != IMAGE_DOS_SIGNATURE)
		return NULL;

	PIMAGE_DOS_HEADER pDosHeader = (PIMAGE_DOS_HEADER)hModule;
	pNtHeaders = (PIMAGE_NT_HEADERS)(pb + pDosHeader->e_lfanew);

	if (((DWORD *)pNtHeaders)[0] != IMAGE_NT_SIGNATURE)
		return NULL;

	pOptionalHeader = &pNtHeaders->OptionalHeader;
	pDirectory = &pOptionalHeader->DataDirectory[IMAGE_DIRECTORY_ENTRY_IMPORT];
	Address = pDirectory->VirtualAddress;

	if (Address == 0)
		return NULL;

	return (PIMAGE_IMPORT_DESCRIPTOR)((ULONG_PTR)hModule + Address);
}

BOOL WINAPI PatchIATInternal(HMODULE hModule, APIHook* APIHookInfo)
{
	// Get original function addresses being hooked
	FARPROC Original = GetProcAddress(GetModuleHandleA(APIHookInfo->module), APIHookInfo->name);
	if (Original == NULL)
		return FALSE;

	// Hold original address
	if (APIHookInfo->original == NULL)
		APIHookInfo->original = (void*)Original;

	// Get base address of our process primary module
	ULONG_PTR BaseAddress = (ULONG_PTR)hModule;

	// Get import table
	PIMAGE_IMPORT_DESCRIPTOR pImageImportDescriptor = GetImportDescriptor(hModule);

	if (pImageImportDescriptor == NULL)
		return FALSE;

	// Search through import table
	for (; pImageImportDescriptor->Name; pImageImportDescriptor++)
	{
		LPCSTR lpDllName = (LPCSTR)(BaseAddress + pImageImportDescriptor->Name);

		if (_stricmp(lpDllName, APIHookInfo->module))
			continue;

		PIMAGE_THUNK_DATA pImageThunkData = (PIMAGE_THUNK_DATA)(BaseAddress + pImageImportDescriptor->FirstThunk);
		PIMAGE_THUNK_DATA pOrgImageThunkData = (PIMAGE_THUNK_DATA)(BaseAddress + pImageImportDescriptor->OriginalFirstThunk);

		for (; pImageThunkData->u1.Function; pImageThunkData++, pOrgImageThunkData++)
		{
			FARPROC pfnImportedFunc = (FARPROC)(pImageThunkData->u1.Function);

			// Patch
			if (pfnImportedFunc == Original)
			{
				OutputDebugStringEx(L"[BypassESU] Replaced %S import 0x%p @ 0x%p with hook entry 0x%p in base 0x%p.\n",
					APIHookInfo->name, (void*)pImageThunkData->u1.Function, (void*)(&pImageThunkData->u1.Function), APIHookInfo->hook, hModule);
				DWORD flOldProtect;
				VirtualProtect(pImageThunkData, sizeof(ULONG_PTR), PAGE_READWRITE, &flOldProtect);
				WriteProcessMemory(GetCurrentProcess(), pImageThunkData, &APIHookInfo->hook, sizeof(ULONG_PTR), NULL);
				VirtualProtect(pImageThunkData, sizeof(ULONG_PTR), flOldProtect, &flOldProtect);
			}
		}
	}

	return TRUE;
}

BOOL WINAPI PatchIAT(HMODULE hModule)
{
	BOOL bRet = TRUE;

	for (int i = 0; i < _countof(APIHooks); i++)
	{
		if (!PatchIATInternal(hModule, &APIHooks[i]))
		{
			bRet = FALSE;
			break;
		}
	}

	return bRet;
}

BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved)
{
	UNREFERENCED_PARAMETER(hinstDLL);
	UNREFERENCED_PARAMETER(lpvReserved);

	OutputDebugStringEx(L"[BypassESU] DllMain entry. [nReason: %u]\n", fdwReason);

	BOOL bRet = TRUE;

	HKEY hKey;
	RegOpenKeyExW(HKEY_LOCAL_MACHINE, CBS_KEY, 0, KEY_READ | KEY_WOW64_64KEY, &hKey);

	WCHAR bufname[256], bufdata[256];
	DWORD sizename = sizeof(bufname), sizedata = sizeof(bufdata), i = 0, type;
	RegEnumValueW(hKey, i, (LPWSTR)bufname, &sizename, NULL, &type , (LPBYTE)bufdata , &sizedata);

	WCHAR bufdst[_MAX_PATH];
	ExpandEnvironmentStringsW((LPCWSTR)bufdata, bufdst, _countof(bufdst));

	WCHAR DLL_ESU[_MAX_PATH];
	swprintf_s(DLL_ESU, _countof(DLL_ESU), L"%s\\%s", bufdst, L"ExtendedSecurityUpdatesAI.dll");

	RegCloseKey(hKey);

	switch (fdwReason)
	{
	case DLL_PROCESS_ATTACH:
	{
		WCHAR CurrentExePath[_MAX_PATH];
		GetModuleFileNameW(NULL, CurrentExePath, _countof(CurrentExePath));
		WCHAR* CurrentExeName = wcsrchr(CurrentExePath, L'\\') + 1;
		if (0 == _wcsicmp(CurrentExeName, L"rundll32.exe"))
		{

		}
		else
		{
			bRet = DisableThreadLibraryCalls(hinstDLL);
			PatchIAT(GetModuleHandleA(NULL));
			LoadLibraryW_Hook(DLL_ESU);
		}

		break;
	}
	case DLL_THREAD_ATTACH:
	case DLL_THREAD_DETACH:
	case DLL_PROCESS_DETACH:
		break;
	}

	return bRet;
}
