/*
IMI Kurwica SLC v1.1 (C) 2020 IMI Kurwica
Enables installation of ESU on supported editions of Windows 7 / Server 2008 R2

This is a fake slc.dll which only replaces SLGetWindowsInformationDWORD.
Everything else is forwarded to the original licensing DLLs.
*/

#define _WIN32_WINNT _WIN32_WINNT_WIN7

#include <windows.h>
#include <slpublic.h>

HRESULT WINAPI SLGetWindowsInformationDWORDNew(
	PCWSTR pwszValueName,
	DWORD *pdwValue
) {
	if (wcsstr(pwszValueName, L"Client-ESU") ||
		wcsstr(pwszValueName, L"Server-ESU") ||
		wcsstr(pwszValueName, L"POS-ESU") ||
		wcsstr(pwszValueName, L"WES-ESU") ||
		wcsstr(pwszValueName, L"Client-FES-ESU") ||
		wcsstr(pwszValueName, L"Server-FES-ESU")
	) {
		*pdwValue = 1;
		return S_OK;
	}

	HRESULT hresultReturn = SLGetWindowsInformationDWORD(
		pwszValueName,
		pdwValue
	);

	return hresultReturn;
}

BOOL APIENTRY WINAPI dll_main(
	HINSTANCE hinstDLL,
	DWORD fdwReason,
	LPVOID lpvReserved
) {
	return TRUE;
}
